import tableWrapper from './packages/table';
import menuWrapper from './packages/menu';
import stepWrapper from './packages/step';
import loaderWrapper from './packages/loader';
import tipWrapper from './packages/tip';
import dialogWrapper from './packages/dialog';
import confirmWrapper from './packages/confirm';

import './packages/table/src/table.less';
import './packages/menu/src/menu.less';
import './packages/step/src/step.less';
import './packages/loader/src/loader.less';
import './packages/tip/src/tip.less';
import './packages/dialog/src/dialog.less';
import './packages/dialog/src/fulldialog.less';
import './packages/confirm/src/confirm.less';

import initJS from './packages/global/js/initJS';

const wrappers = [
    tableWrapper,
    menuWrapper,
    stepWrapper,
    loaderWrapper,
    tipWrapper,
    dialogWrapper.commonDialog,
    dialogWrapper.fullDialog,
    confirmWrapper
];

for(let i = 0, len = wrappers.length; i < len; i++) {
    const wrapper = wrappers[i];
    const name = wrapper.getName();
    if(wrapper.getScope && wrapper.getScope() == 'Global') {
        $[name] = function() {
            return initJS.resolveArgs(null, wrapper, arguments);
        };
    }
    else {
        $.fn[name] = function() {
            return initJS.resolveArgs(this, wrapper, arguments);
        };
    }
}

export default wrappers;