const DEFAULT = {
    title: "对话框",
    content: "对话框内容",
    enableMax: false,
    onCloseEvent: null,
    frame: null,
};

class FullDialogWrapper {
    constructor(_el, _options) {
        this._options = Object.assign({}, JSON.parse(JSON.stringify(DEFAULT)), _options);
    }

    static getName() {
        return 'FullDialogWrapper';
    }

    static getScope() {
        return 'Global';
    }

    init() {
        let _this = this, options = this._options, $el,
            content = options.frame
            ? `<iframe width="100%" height="100%" frameborder="0" style="display: block;" src="${options.frame}"></iframe>`
            : options.content;
        if($(".cr-fulldialog-backdrop").length > 0) {
            $el = _this._el = $(".cr-fulldialog-backdrop");
            $el.find(".cr-fulldialog-title").text(options.title);
            $el.find(".cr-fulldialog-body").html(content);
        }
        else {
            $el = _this._el = $(`
                <div class="cr-fulldialog-backdrop">
                    <div class="cr-fulldialog-container">
                        <div class="cr-fulldialog-head">
                            <div class="cr-fulldialog-title">${options.title}</div>
                            <div class="cr-fulldialog-tools">
                                <i class="cr-fulldialog-tool cr-fulldialog-close">&times;</i>
                            </div>
                        </div>
                        <div class="cr-fulldialog-body container-fluid">${content}</div>
                    </div>
                </div>
            `).appendTo(document.body);

        }

        let $frame = $el.find(".cr-fulldialog-body").find("iframe");
        // $frame.on('load', function() {
        //     console.log("加载成功");
        // });
        // console.log("还在加载");

        $el.off('click');
        $el.on('click', '.cr-fulldialog-close', function () {
            // 关闭事件
            options.onCloseEvent && options.onCloseEvent.call(_this);
            _this.close();
        });

        return this;
    }

    open() {
        let $el = this._el, $frame = $el.find(".cr-fulldialog-body").find("iframe");

        // iframe延迟加载, 防止iframe对show动画有影响
        if($frame.length > 0) {
            $frame.on('load', function() {
                $el.fadeIn();
                $el.find(".cr-fulldialog-container").addClass("show");
            });
        }
        else {
            $el.fadeIn();
            $el.find(".cr-fulldialog-container").addClass("show");
        }

        return this;
    }

    close() {
        let $el = this._el;
        $el.fadeOut();
        $el.find(".cr-fulldialog-container").removeClass("show");

        return this;
    }
}

export default FullDialogWrapper