const TypeEnum = {
    'STRING' : '[object String]',
    'OBJECT' : '[object Object]',
    'FUNCTION' : '[object Function]',
    'ARRAY' : '[object Array]',
    'NUMBER' : '[object Number]',
    'BOOLEAN' : '[object Boolean]',
};

const ResolveEnum = {
    STRING(obj) {
        return obj;
    },
    OBJECT(obj) {

        let newObj = {};

        for(let key in obj) {
            newObj[key] = deepClone(obj[key]);
        }

        return newObj;

    },
    FUNCTION(obj) {
        return obj;
    },
    ARRAY(obj) {
        let newArr = [];

        obj.map((item, index) => {
            newArr.push(deepClone(item));
        });

        return newArr;
    },
    NUMBER(obj) {
        return Number(obj);
    },
    BOOLEAN(obj) {
        return obj;
    }
};

function deepClone(obj) {
    // 如果是null, undefined, '', 0, 字符串这些,就别来捣乱了,出去吧
    if(!obj) {
        return obj;
    }

    return ResolveEnum[getType(obj)](obj);
}

function getType(obj) {

    let type = Object.prototype.toString.call(obj);

    for(let key in TypeEnum) {
        if(type === TypeEnum[key]) {
            return key;
        }
    }

}

export default deepClone