class LoaderWrapper {
    constructor(_el, options) {
        this._options = options;
    }

    static getName() {
        return "LoaderWrapper";
    }

    static getScope() {
        return 'Global';
    }

    init() {
        let $loaderContainer;
        if($('.cr-loader-container').length > 0) {
            $loaderContainer = $('.cr-loader-container');
        }
        else {
            $loaderContainer =
                $(
                    "<div class='cr-loader-container modal fade bs-example-modal-sm' role='dialog' tabindex='-1'>" +
                    "<div class='modal-dialog modal-sm' role='document'>" +
                    "<div class='modal-content'>" +
                    "<div class='modal-header'><h5>请等待...</h5></div>" +
                    "<div class='modal-body'>" +
                    "<div class='progress progress-striped active'>" +
                    "<div class='progress-bar' style='width: 100%;'></div>" +
                    "</div></div></div></div></div>"
                ).appendTo(document.body);
        }

        this._el = $loaderContainer;
        return this;

    }
    open() {
        this._el.modal('show');
        return this;
    }
    close() {
        this._el.modal('hide');
        return this;
    }

}

export default LoaderWrapper