import DeepClone from '../../global/js/DeepClone';

/***
 *
 * @type {{message: string, icon: string, type: string}}
 *
 * @param type {primary: 黑色(default), danger: 红色渐变, info: 灰色}
 */
const DEFAULT = {
    message: "消息提示",
    icon: "glyphicon glyphicon-bell",
    type: "primary"
};

class TipWrapper {
    constructor(_el, _options) {
        this._options = Object.assign({}, DeepClone(DEFAULT), _options);
    }

    static getName() {
        return 'TipWrapper';
    }

    static getScope() {
        return 'Global';
    }

    init() {
        let $el, message = this._options.message, icon = this._options.icon, type = this._options.type;

        if($('.cr-tip').length > 0) {
            $el = $('.cr-tip');
            $el.append("<br/><div class='cr-tip-content cr-tip-" + type + "'><i class='" + icon + "'></i>&nbsp;&nbsp;<div class='cr-tip-message'>" + message + "</div>&nbsp;&nbsp;<i class='cr-tip-close'>&times;</i></div>");
        }
        else {
            $el = $("<div class='cr-tip'></div>").appendTo(document.body);
            $el.append("<div class='cr-tip-content cr-tip-" + type + "'><i class='" + icon + "'></i>&nbsp;&nbsp;<div class='cr-tip-message'>" + message + "</div>&nbsp;&nbsp;<i class='cr-tip-close'>&times;</i></div>");
        }

        this._el = $el;
        return this;
    }

    open() {
        let $el = this._el;
        $el.children().addClass("show");

        if("animation" in document.body.style) {
            $el.children().one('webkitAnimationEnd mozAnimationEnd MSAnimationEnd oAnimationend animationend', function() {
                $el.remove();
            });
        }
        else {
            // 兼容旧浏览器
            setTimeout(function () {
                if($el.length > 0) {
                    $el.remove();
                }
            }, 3000);
        }

        return this;

    }
}

export default TipWrapper;
